﻿<div align="center">


</div>

## Install
```sh
$ npm i inline-reply
```
## Setup
```js
const discord = require('discord.js');
require('discord-inline-reply'); //⚠️ IMPORTANT: put this before your discord.Client()
const client = new discord.Client();
```

<h1>Discord.js</h2>

## Example
```js
const discord = require('discord.js');
require('discord-inline-reply'); //⚠️ IMPORTANT: put this before your discord.Client()
const client = new discord.Client();

client.on('ready', () => {
  console.log(client.user.tag)
});

client.on('message', async message => {
  if (message.content.startsWith('!reply')) {
    message.lineReply('Hey'); //Line (Inline) Reply with mention

    message.lineReplyNoMention(`My name is ${client.user.username}`); //Line (Inline) Reply without mention
  }
});

client.login('TOKEN');
```
## Preview
</a>
<a href="https://github.com/OmBodkhe1/">
<img align ="left" alt="Om's Github" width="1000px" src ="https://i.imgur.com/5uPSD43.png" />
</a>  <br/> 


## Embed
```js
if (message.content.startsWith('!reply')) {
  let embed = new discord.MessageEmbed()
  .setDescription(`Reply to ${message.author}`);

  message.lineReply(embed); //Line (Inline) Reply with mention

  //or

  message.lineReplyNoMention(embed); //Line (Inline) Reply without mention
}
```
## Preview
</a>
<a href="https://github.com/OmBodkhe1/">
<img align ="left" alt="Om's Github" width="1000px" src ="https://i.imgur.com/PpYHaik.png" />
</a>  <br/> 


<h2 style="display:inline;">Edit</h2> <h4 style="display:inline;">(Async Function)</h4>

```js
if (message.content.startsWith('!ping')) {

  let m = await message.lineReply('Ping');

  let ping = (m.createdTimestamp - message.createdTimestamp);

  m.edit(`${ping}ms`)
}
```

## Command Handler
```js
/**
 * No need to define it
 * */
module.exports = {
  name: 'reply',
  category: 'Test',
  run: (client, message, args) => {
    message.lineReply('This is reply with @mention');
  }
}
```


<hr>
